/*******************************************************************************
 * Copyright (c) 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Matthew Webster           initial implementation      
 *******************************************************************************/

package demo.eclipse.logging;

import org.aspectj.lib.logging.PluginFFDC;
import org.eclipse.core.runtime.ILog;
import org.eclipse.core.runtime.IStatus;
import org.eclipse.core.runtime.Platform;
import org.osgi.framework.Bundle;
import org.osgi.service.packageadmin.PackageAdmin;

public abstract aspect Logging extends PluginFFDC {

	private final static String BUNDLE_NAME = "demo.eclipse.logging";
	
	private static PackageAdmin packageAdminService;
	private Bundle bundle = Platform.getBundle(BUNDLE_NAME);
	
	public static void setPackageAdminService (PackageAdmin packageAdmin) {
//		System.err.println("? Logging.setPackageAdminService() packageAdmin=" + packageAdmin);
		packageAdminService = packageAdmin;
	}
	
    protected String getPluginId (Class clazz) {
//    	System.err.println("> Logging.getPluginId() clazz=" + clazz);
    	
    	String symbolicName = BUNDLE_NAME;
    	if (packageAdminService != null) {
        	Bundle bundle = packageAdminService.getBundle(clazz);
        	symbolicName = (bundle == null)? "null" : bundle.getSymbolicName();
    	}
    	
//    	System.err.println("< Logging.getPluginId() " + symbolicName);
    	return symbolicName;
    }
    
    protected void log (IStatus status) {
    	ILog log = Platform.getLog(bundle);
    	log.log(status);
    }

}
