/*******************************************************************************
 * Copyright (c) 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Matthew Webster           initial implementation      
 *******************************************************************************/

package org.aspectj.osgi.service.tracing;

import java.util.Properties;

import org.osgi.framework.BundleActivator;
import org.osgi.framework.BundleContext;
import org.osgi.framework.ServiceReference;
import org.osgi.framework.ServiceRegistration;

import demo.eclipse.tracing.ITrace;

public class TraceServiceBundle implements BundleActivator {

	public static boolean verbose = Boolean.getBoolean("org.aspectj.osgi.service.tracing.verbose");
	private ServiceRegistration serviceRegistration;

	public void start(BundleContext context) throws Exception {
//		System.err.println("> TraceServiceBundle.start() " + context);
		if (verbose) System.err.println("info Starting Trace service ...");
		String serviceName     = ITrace.class.getName();
		ITrace traceService = new TraceService();
		Properties props       = new Properties();
		serviceRegistration = context.registerService(serviceName, traceService, props);
//		System.err.println("< TraceServiceBundle.start() " + serviceRegistration);
	}

	public void stop(BundleContext context) throws Exception {
//		System.err.println("> TraceServiceBundle.stop() " + serviceRegistration);
		serviceRegistration.unregister();
//		System.err.println("< TraceServiceBundle.stop() " + serviceRegistration);
	}

}
