/*******************************************************************************
 * Copyright (c) 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Matthew Webster           initial implementation      
 *******************************************************************************/

package demo.eclipse.swt.translators;

import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseTrackListener;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.ToolItem;

public aspect TooltipInterceptor implements MouseTrackListener {

	public static boolean verbose = false;

	before (Object thiz, Control control) : execution(public void setControl (..)) && this(thiz) && args(control) {
//		System.err.println("? TooltipInterceptor.before() " + thisJoinPoint.getSignature() + " this=" + thiz + ", control=" + control);
		if (control != null) {
			control.addMouseTrackListener(this);
		}
	}
	
//	after (Control control) returning : execution(CTabFolder+.new(..)) && this(control) && !within(TooltipInterceptor+) {
////		System.err.println("? TooltipInterceptor.before() " + thisJoinPoint.getSignature());
//		control.addMouseTrackListener(this);
//	}

	declare parents : ToolItem implements IToolTipText;
	declare parents : Control implements IToolTipText;
	
	private MouseTrackListener delegate;
	
	public static void addMouseTrackListener (MouseTrackListener listener) {
		aspectOf().delegate = listener;
	}
	
	public void mouseEnter(MouseEvent e) {
		if (delegate != null) delegate.mouseEnter(e);
	}

	public void mouseExit(MouseEvent e) {
		if (delegate != null) delegate.mouseExit(e);
	}

	public void mouseHover(MouseEvent e) {
		if (delegate != null) delegate.mouseHover(e);
	}
}