/*******************************************************************************
 * Copyright (c) 2006 IBM Corporation and others.
 * All rights reserved. This program and the accompanying materials
 * are made available under the terms of the Eclipse Public License v1.0
 * which accompanies this distribution, and is available at
 * http://www.eclipse.org/legal/epl-v10.html
 * 
 * Contributors:
 *   Matthew Webster           initial implementation      
 *******************************************************************************/

package demo.eclipse.translators;

import java.io.IOException;
import java.io.InputStream;
import java.util.Properties;

public abstract class Translator implements ITranslationProvider {

	private Properties props;
	private String unknown;

	public Translator (String language, String unknown) {
		loadProperties(language + ".properties");
		this.unknown = unknown;
	}

	protected void loadProperties(String fileName) {
		this.props = new Properties();
		
		try {
			InputStream in =  getClass().getResourceAsStream(fileName);
			props.load(in);
			in.close();
		}
		catch (IOException ex) {
			ex.printStackTrace();
		}
	}

	public String translate(String text) {
		String after = props.getProperty(text,unknown);
		
		return after;
	}

}
